View Issue Details

IDProjectCategoryView StatusLast Update
0000034PluginsFARCmdspublic2014-07-09 18:04
ReporteralexfhAssigned Tovskirdin 
PrioritynormalSeverityminorReproducibilityalways
Status closedResolutionfixed 
Product Version 
Target VersionFixed in Version3.0 
Summary0000034: неправильная обработка кавычек в строках FARCmds
DescriptionТакой вариант работает нормально (открывает во вьюере вывод соответствующей
команды):
view:<"c:\Program Files\Far\toolz\grep.exe" test *.exe

а такой выдает "'c:\Program' is not recognized as an internal or external
command, operable program or batch file":
view:<"c:\Program Files\Far\toolz\grep.exe" test "*.exe"
Additional Information------- Additional Comments From Valentin Skirdin 2004-02-02 23:14 -------


В farbugs@ я просил составить таблицу по этому поводу :-)
а воз и ныне там.


------- Additional Comments From Alexander Kornienko 2004-02-10 00:34 -------


Гм, че-то там сложно слишком было чтобы вникать Ж;-)
Можешь еще то же самое еще раз запостить со всеми необходимыми комментариями?
Может тогда воз сдвинется ))


------- Additional Comments From Alex Yaroslavsky 2004-05-26 22:58 -------


Валя, напомни какую таблицу тебе надо дать чтоб это починить, а то при
[HKEY_CURRENT_USER\Software\Far\System\Executor]
"Type"=dword:00000001

это всё ещё не пашет.


------- Additional Comments From Valentin Skirdin 2004-05-26 23:08 -------


http://groups.yahoo.com/group/farbugs/message/19301
<msgid:444411996.20040112165754@cell.vrn.ru>

Народ, кто может провести "расследование"?
Тема: че нужно для cmd/command/4nt для вариантов:

1. program "параметры для программы"
2. "program" "параметры для программы"

Как для start, так и в текущем окне...
Для Type=1 и Type=0

т.е. результат... потом оформится в таблицы...
аля:


------------------------------------------------------>8----
Type=0
              | в этом окне | start |
              |prog "param" | "prog" "param"|prog "param" | "prog" "param"|
--------------+-------------+---------------+-------------+---------------+
command.com | | | | |
cmd.exe | | | | |
4nt.exe | | | | |
----8<------------------------------------------------------

------------------------------------------------------>8----
Type=1
              | в этом окне | start |
              |prog "param" | "prog" "param"|prog "param" | "prog" "param"|
--------------+-------------+---------------+-------------+---------------+
command.com | | | | |
cmd.exe | | | | |
4nt.exe | | | | |
----8<------------------------------------------------------

а то... что-то мне сдается - топчимся на одном месте....

ЗЫ.
  Если нужно - отдам на "разграбление" функцию Execute()


Но судя по всему это сам плагин надо править... т.к.
это он исполняет программу. А то, что он не дружит с кавычками -
это другой расклад.


------- Additional Comments From Alex Yaroslavsky 2004-05-27 15:15 -------


Может в плагине тоже баг, но в ФАРе тоже:

cmd.exe

когда Type==0 всё ОК.

когда Type==1 и Start=="" || Start="%COMSPEC% /c start"
то по Shift-Enter всё ОК
а по Enter не срабатывают prog "param" и "prog" "param" если путь к prog
сожержит пробелы
а когда Type==1 и "Start"="%COMSPEC% /c start %COMSPEC% /k"
то и по Shift-Enter тоже поведение

например prog="G:\Program Files\ht.exe" param="не имеет значения"
баг видно запуская prog с полным путём, или только по имени файла находясь в
"G:\Program Files" папке.

Также при Type==1 не находится команда exit если её не упамянуть в ExcludeCmds,
например echo да находится.
TagsNo tags attached.

Activities

vskirdin

2006-12-14 08:25

administrator   bugnote:0000359

после билда 22

Грязный хак:
строку
"c:\Program Files\Far\toolz\grep.exe" test "*.exe"
преобразовал в
""c:\Program Files\Far\toolz\grep.exe" test "*.exe"
т.е. добавил '"' в начало
:-)

JohnDoe

2014-07-08 20:50

updater   bugnote:0012684

Last edited: 2014-07-08 21:14

View 2 revisions

edit:<"C:\Apps\Far3\Far.exe" "d:\"

'C:\Apps\Far3\Far.exe" "d:\' is not recognized as an internal or external command,
operable program or batch file.


edit:<"echo" "test"

'echo" "test' is not recognized as an internal or external command,
operable program or batch file.

vskirdin

2014-07-09 09:52

administrator   bugnote:0012702

edit:<"echo" "test"
формируется в
C:\Windows\System32\cmd.exe /c "echo" "test"

edit:<"C:\Program Files\Far3\Far.exe" "d:\"
формируется в
C:\Windows\System32\cmd.exe /c "C:\Program Files\Far3\Far.exe" "d:\"

И cmd подобные ошибки выдает.

Причем, добавка вначале одну двойную кавычку
C:\Windows\System32\cmd.exe /c ""C:\Program Files\Far3\Far.exe" "d:\"
то работает...

JohnDoe

2014-07-09 10:51

updater   bugnote:0012703

Last edited: 2014-07-09 10:53

View 2 revisions

Надо всё взять в ещё одни кавычки
cmd.exe /c ""C:\Program Files\Far3\Far.exe" "d:\""

http://technet.microsoft.com/en-us/library/bb490880.aspx
...If the previous conditions are not met, string is processed by examining the first character to verify whether or not it is an opening quotation mark. If the first character is an opening quotation mark, it is stripped along with the closing quotation mark. Any text following the closing quotation marks is preserved.

vskirdin

2014-07-09 11:48

administrator   bugnote:0012705

build 118

JohnDoe

2014-07-09 18:03

updater   bugnote:0012712

Порядок

Issue History

Date Modified Username Field Change
2005-10-24 22:15 alexfh New Issue
2005-10-25 01:41 alexy Project Far Manager 1.7x => Plugins
2005-10-25 01:43 alexy Category Command Line/Execute => FARCmds
2006-12-14 08:22 vskirdin Status new => assigned
2006-12-14 08:22 vskirdin Assigned To => vskirdin
2006-12-14 08:25 vskirdin Status assigned => resolved
2006-12-14 08:25 vskirdin Fixed in Version => 1.71
2006-12-14 08:25 vskirdin Resolution open => fixed
2006-12-14 08:25 vskirdin Note Added: 0000359
2007-07-16 16:06 alexy Status resolved => closed
2014-07-08 20:50 JohnDoe Note Added: 0012684
2014-07-08 20:50 JohnDoe Status closed => feedback
2014-07-08 20:50 JohnDoe Resolution fixed => reopened
2014-07-08 21:14 JohnDoe Note Edited: 0012684 View Revisions
2014-07-09 09:52 vskirdin Note Added: 0012702
2014-07-09 10:51 JohnDoe Note Added: 0012703
2014-07-09 10:53 JohnDoe Note Edited: 0012703 View Revisions
2014-07-09 11:48 vskirdin Note Added: 0012705
2014-07-09 18:03 JohnDoe Note Added: 0012712
2014-07-09 18:04 vskirdin Status feedback => closed
2014-07-09 18:04 vskirdin Resolution reopened => fixed
2014-07-09 18:04 vskirdin Fixed in Version 1.71 => 3.0